#!/usr/bin/perl 

use CGI::Carp qw(fatalsToBrowser);
use diagnostics;
use warnings;
use strict;

use CGI qw(:standard);

use DBI;

use Text::Template;

use lib ('./');

my ($start,$name,$value,$anz,%cookies,$bb,$html,$c,$time,$cookieusername,$cookiepassword,$entry,%list,$sth,$tmp,$temp,$temporar,$hits,$count,$all,@wort,@bedingung,@users,@lines,@az,$checked,$status);
our ($input,%input,%lx);

require "config.cgi";
use vars qw(%config); 

our $scripturl = "print.cgi";

if ($config{'baselang'} && -e "language/$config{'baselang'}.lang") {require "language/$config{'baselang'}.lang";}
else {require "Data/LANG";}
our %l = &lang();

require "lib.cgi";

if(param){
my $x=new CGI;
$temporar = $x->Vars;
foreach (keys(%$temporar)) {$input{"$_"} = $$temporar{$_};}
}

if ($name eq 'wort' || $name eq 'letter' || $name eq 'abkuerzung' || $name eq 'definition' || $name eq 'sprache' || $name eq 'quelle' || $name eq 'lang' || $name eq 'id' || $name eq 'status' || $name eq 'page') {
$input{$name} = &sec_sql($input{$name});
}

print "Content-type: text/html\n\n";

	print qq~
	<html>
	<head>
	<title>$l{printable}</title>
	<style type="text/css">
	<!--
	body {
	font-size: 12px;
	font-family: Verdana, Arial, Sans-serif;
	color: #000000;
	background-color: #FFFFFF;
	}
	td {
	font-size: 12px;
	font-family: Verdana, Arial, Sans-serif;
	}
	input, textarea, select {
	font-size: 11px;
	font-family: Verdana, Arial, Sans-Serif;
	background-color: #ffffff;
	border: 1 solid #000000;
	}
	hr {
	backgorund-color: #ffffff;
	color: #000000;
	line-height: 1px;
	}
	.u {
	border-bottom: double #000000 3px;
	}
	.b {
	font-weight: bold;
	}
	.i {
	font-style: italic;
	}
	a {
	color: #0033CC;
	text-decoration: underline;
	}
	.border {
	background-color: #000000;
	}
	.obox {
	background-color: #eeeeee;
	}
	.mbox {
	background-color: #ffffff;
	}
	.ubox {
	background-color: #ffffff;
	}
	.mmbox {
	background-color: #f9f9f9;
	}
	.otext {
	font-size: 12px;
	font-family: Verdana, Arial, Sans-Serif;
	}
	.mtext {
	font-size: 11px;
	font-family: Verdana, Arial, Sans-Serif;
	}
	.mtext:first-letter {
	font-weight: bold;
	}
	.utext {
	font-size: 11px;
	font-family: Verdana, Arial, Sans-Serif;
	}
	.ntext {
	font-size: 12px;
	font-family: Verdana, Arial, Sans-Serif;
	}
	.btext {
	font-size: 14px;
	font-family: Verdana, Arial, Sans-Serif;
	font-weight: bold;
	}
	.highlight {
	border: double black 3;
	text-weight: bold;
	}
	-->
	</style>
	<link rel="SHORTCUT ICON" href="$config{'htmldir'}/favicon.ico">
	</head>
	<body bgcolor="white" text="black">
	<p align=right><font class="utext"><a href="http://$ENV{HTTP_HOST}$ENV{REQUEST_URI}">http://$ENV{HTTP_HOST}$ENV{REQUEST_URI}</a></font></p>
	~;

	our $dbh = DBI->connect("$config{'treiber'}:host=$config{'hostname'};database=$config{'dbname'}","$config{'dbusername'}","$config{'dbuserpass'}", {PrintError => 1, RaiseError => 1});


	my $time = time();
	my $tt = $time-86400;

if (-e "counter.txt") {

	open(FILE,"counter.txt");
	@lines  = (<FILE>);
	close(FILE);
	
	@users = ();

	chomp $lines[0];

	my ($count,$hits) = split(/\|/,$lines[0]);
	$hits++;
	$count++;

	foreach (@lines) {

	chomp $_;

	if ($_ =~ /-/) {	
	my ($c_user,$t) = split(/-/,$_);

		if ($t < $tt) {next;}

		if ($ENV{'REMOTE_ADDR'} eq $c_user) {
  			$count--;
			push (@users,"$ENV{'REMOTE_ADDR'}-$time");
			$temp = "1";
		}
		else {
			push (@users,"$c_user-$t");
		}
	}
	}	
	
	if (!$temp) {
		push (@users,"$ENV{'REMOTE_ADDR'}-$time");
	}

	open(FILE,">counter.txt");
	print FILE "$count|$hits\n";
	foreach (@users) {
	print FILE "$_\n";
	}
	close(FILE);

}
else {
$count = "1";
$hits = "1";

	open(FILE,">counter.txt");
	print FILE "$count|$hits\n";
	print FILE "$ENV{'REMOTE_ADDR'}-$time\n";
	close(FILE);
}

	if ($input{'action'} eq "result") {

	if (length $input{'wort'} >= "3") {

        my $v = "OR"; 
		$temporar = "?action=result&wort=$input{wort}&sprache=$input{sprache}&quelle=$input{quelle}&status=$input{status}&id=$input{id}";

	if ($input{sprache} eq "ungenau") {

		@wort = split (/\s+/, $input{'wort'});

		foreach (@wort) {
        	$tmp ="(wort LIKE '%$_%') $v (abkuerzung LIKE '%$_%') $v (definition LIKE '%$_%') $v (quelle LIKE '%$_%') $v (sprache LIKE '%$_%')";
		}

	$anz = $dbh->selectrow_array("SELECT COUNT(*) FROM $config{'dbwords'} WHERE status='0' AND $tmp");

	($temp,$start) = &get_nav($anz,$temporar);

	print $temp;

	$sth = $dbh->prepare("SELECT id, wort, abkuerzung, definition, sprache, quelle, status FROM $config{'dbwords'} WHERE status='0' AND $tmp ORDER BY $input{status} $input{quelle} LIMIT $start,$config{'persite'}	");
	
	}
	else {

	$anz = $dbh->selectrow_array("SELECT COUNT(*) FROM $config{'dbwords'} WHERE status='0' AND (wort LIKE \"%$input{wort}%\") OR (abkuerzung LIKE \"%$input{wort}%\") OR (definition LIKE \"%$input{wort}%\") OR (sprache LIKE \"%$input{wort}%\") OR (quelle LIKE \"%$input{wort}%\")");

	($temp,$start) = &get_nav($anz,$temporar);

	print $temp;

	$sth = $dbh->prepare("SELECT id, wort, abkuerzung, definition, sprache, quelle, status FROM $config{'dbwords'} WHERE status='0' AND (wort LIKE \"%$input{wort}%\") OR (abkuerzung LIKE \"%$input{wort}%\") OR (definition LIKE \"%$input{wort}%\") OR (sprache LIKE \"%$input{wort}%\") OR (quelle LIKE \"%$input{wort}%\") ORDER BY $input{status} $input{quelle} LIMIT $start,$config{'persite'}	");	

	}
   
	$sth->execute() or die DBI->errstr;

	while (my $list = $sth->fetchrow_hashref()) { 
		$entry = &get_entry($list->{id},$list->{wort},$list->{abkuerzung},$list->{definition},$list->{sprache},$list->{quelle},$list->{status});

			if ($input{sprache} eq "ungenau") {
			foreach $temp (@wort) {
				$entry =~ s/($temp)/<span class=\"highlight\">$1<\/span>/isg;
			}}
			else {
				$entry =~ s/($input{'wort'})/<span class=\"highlight\">$1<\/span>/isg;
			}

		print $entry;	 
	}
	}
	else {
	print qq~
	<font class="ntext">$l{search_error}<br>
	<a href="javascript: history.back(-1);">$l{back}</a></font>
	~;
	}

	}
	
	elsif ($input{'letter'}) {

	if ($input{'letter'} ne "num") {
	$anz = $dbh->selectrow_array("SELECT COUNT(*) FROM $config{'dbwords'} WHERE wort LIKE '$input{letter}%' AND status='0' ORDER BY wort ASC, abkuerzung ASC");
	}
	else {
	$anz = $dbh->selectrow_array("SELECT COUNT(*) FROM $config{'dbwords'} WHERE wort LIKE '0%' OR wort LIKE '1%' OR wort LIKE '2%' OR wort LIKE '3%' OR wort LIKE '4%' OR wort LIKE '5%' OR wort LIKE '6%' OR wort LIKE '7%' OR wort LIKE '8%' OR wort LIKE '9%' OR wort LIKE '%' OR wort LIKE '%' OR wort LIKE '%' AND status='0' ORDER BY wort ASC, abkuerzung ASC");
	}

	($temp,$start) = &get_nav($anz,"?action=show&letter=$input{'letter'}");

	print $temp;

	if ($input{'letter'} ne "num") {
	$sth = $dbh->prepare("SELECT id, wort, abkuerzung, definition, sprache, quelle, status FROM $config{'dbwords'} WHERE wort LIKE '$input{letter}%' AND status='0' ORDER BY wort ASC, abkuerzung ASC LIMIT $start,$config{'persite'}	");
	}
	else {
	$sth = $dbh->prepare("SELECT id, wort, abkuerzung, definition, sprache, quelle, status FROM $config{'dbwords'} WHERE wort LIKE '0%' OR wort LIKE '1%' OR wort LIKE '2%' OR wort LIKE '3%' OR wort LIKE '4%' OR wort LIKE '5%' OR wort LIKE '6%' OR wort LIKE '7%' OR wort LIKE '8%' OR wort LIKE '9%' OR wort LIKE '%' OR wort LIKE '%' OR wort LIKE '%' AND status='0' ORDER BY wort ASC, abkuerzung ASC LIMIT $start,$config{'persite'}	");
	}
	$sth->execute() or die DBI->errstr;
   
	while (my $list = $sth->fetchrow_hashref()) {
   
		$entry = &get_entry($list->{id},$list->{wort},$list->{abkuerzung},$list->{definition},$list->{sprache},$list->{quelle},$list->{status});
		print $entry;
   		 
	}

	$sth->finish();

	}

	elsif ($input{'id'}) {

	$sth = $dbh->prepare("SELECT id, wort, abkuerzung, definition, sprache, quelle, status FROM $config{'dbwords'} WHERE id='$input{id}' AND status!='1'");
	$sth->execute() or die DBI->errstr;
   
	while (my $list = $sth->fetchrow_hashref()) {
   
		$entry = &get_entry($list->{id},$list->{wort},$list->{abkuerzung},$list->{definition},$list->{sprache},$list->{quelle},$list->{status});
		print $entry;
   		 
	}

	$sth->finish();

	}

	elsif ($input{'job'} eq "index") {

	$anz = $dbh->selectrow_array("SELECT COUNT(*) FROM $config{'dbwords'} WHERE status='0'");

	$config{'persite'}	 *= 5;

	($temp,$start) = &get_nav($anz,'?action=show&job=index');

	print $temp;

	$sth = $dbh->prepare("SELECT id, wort, abkuerzung, status FROM $config{'dbwords'} WHERE status='0' ORDER BY wort ASC, abkuerzung ASC LIMIT $start,$config{'persite'}	");
	$sth->execute() or die DBI->errstr;
   
	print qq~
<table border="0" width="100%" cellspacing="1" cellpadding="4" class="border">
  <tr>
    <td width="100%" class="obox"><font class="otext"><img align="right" border=0 alt="$l{recommend}" src="$config{'htmldir'}/recommend.gif"><a href="print.cgi?action=show&job=index&page=$input{'page'}"><img align="right" border=0 alt="$l{printable}" src="$config{'htmldir'}/print.gif"></a>$l{index}</font></td>
  </tr>
  <tr>
    <td width="100%" class="mbox"><font class="mtext">
<ul>
	~;

	while (my $list = $sth->fetchrow_hashref()) {
		$entry = &get_index($list->{id},$list->{wort},$list->{abkuerzung},$list->{status});
		print $entry; 
	}

	print qq~
</font></ul>
</td></tr></table>
	~;

	}

	else {

	$anz = $dbh->selectrow_array("SELECT COUNT(*) FROM $config{'dbwords'} WHERE status='0'");

	($temp,$start) = &get_nav($anz,'?action=show');

	print $temp;

	$sth = $dbh->prepare("SELECT id, wort, abkuerzung, definition, sprache, quelle, status FROM $config{'dbwords'} WHERE status='0' ORDER BY wort ASC, abkuerzung ASC LIMIT $start,$config{'persite'}	");
	$sth->execute() or die DBI->errstr;
   
	while (my $list = $sth->fetchrow_hashref()) {
		$entry = &get_entry($list->{id},$list->{wort},$list->{abkuerzung},$list->{definition},$list->{sprache},$list->{quelle},$list->{status});
		print $entry;
   		 
	}

	$sth->finish();


	}

	$dbh->disconnect();

	print qq~
	<p align="center"><span style="color:#ffffff; background-color:#555555;">&copy by VisCacha Glossar $config{'version'} - http://www.mamo-net.de</p>
	</body></html>
	~;

exit(0);