#!/usr/bin/perl 

use CGI::Carp qw(fatalsToBrowser);
use CGI qw(param);
use lib ('./');

$input{action} = param('action');
$config{'password'} = param('password');
$config{'username'} = param('username');
$config{'htmldir'} = param('quelle');
$config{'baselang'} = param('lang');
$config{'host'} = param('host');
$config{'dbusername'} = param('dbusername');
$config{'dbuserpass'} = param('dbpassword');
$config{'datenbank'} = param('datenbank');
$config{'driver'} = param('driver');
$config{'dbwords'} = param('dbwords');

print "Content-type: text/html\n\n";

if ($input{action} eq "step1") {

require "config.cgi";
use vars qw(%config); 

	print qq~
Step 1<br>
Choose your settings and check the given...<br>
<form method="POST" action="update.cgi" name="postmsg">
  <table border="1" width="100%">
    <tr>
      <td width="50%"><b>Path</b> to the HTML-Directory (inside there are images etc.)</td>
      <td width="50%"><input type="text" name="quelle" size="50" value="$config{'htmldir'}"></td>
    </tr>
    <tr>
      <td width="50%"><b>Language</b></td>
      <td width="50%"><select size="1" name="lang">~;

	opendir(DIR, "./language/");
	my @contents = readdir(DIR);
	closedir(DIR);

	foreach $tmp (@contents){
		($temp, $temporar) = split (/\./, $tmp);
		if ($temporar eq "lang"){
			require "language/$tmp";
			my %langinfos = &lang_infos();
			print qq~<option value="$temp">$langinfos{language_name} ($langinfos{version})</option>~;
		}
	}

	print qq~
	</select></td>
    </tr>
    <tr>
      <td width="100%" colspan="2">
        <p align="center"><b>Admin</b></td>
    </tr>
    <tr>
      <td width="50%">Username</td>
      <td width="50%"><input type="text" name="username" size="50" value="$config{'username'}"></td>
    </tr>
    <tr>
      <td width="50%">Password</td>
      <td width="50%"><input type="password" name="password" size="50" value="$config{'password'}"></td>
    </tr>
    <tr>
      <td width="100%" colspan="2">
        <p align="center"><b>Database</b></td>
    </tr>
    <tr>
      <td width="50%">Host</td>
      <td width="50%"><input type="text" name="host" size="50" value="$config{'host_name'}"></td>
    </tr>
    <tr>
      <td width="50%">Database</td>
      <td width="50%"><input type="text" name="datenbank" size="50" value="$config{'db_name'}"></td>
    </tr>
    <tr>
      <td width="50%">Username</td>
      <td width="50%"><input type="text" name="dbusername" size="50" value="$config{'user_name'}"></td>
    </tr>
    <tr>
      <td width="50%">Password</td>
      <td width="50%"><input type="password" name="dbpassword" size="50" value="$config{'user_pass'}"></td>
    </tr>
    <tr>
      <td width="50%">Driver/Modul (often DBI:mysql or DBD:mysql)</td>
      <td width="50%"><input type="text" name="driver" size="20" value="DBI:mysql"></td>
    </tr>
    <tr>
      <td width="50%">Tablename (recommend viscacha_words)</td>
      <td width="50%"><input type="text" name="driver" size="20" value="viscacha_words"></td>
    </tr>
    <tr>
      <td width="100%" colspan="2">
        <p align="center"><input type="hidden" value="step2" name="action"><input type="submit" value="next step: save Data" name="B1"></td>
    </tr>
  </table>
</form>
	~;

	}

elsif ($input{action} eq "step2") {

		open(FILE, ">config.cgi");
  		print FILE qq~
%config = (
htmldir		=>	"$config{'htmldir'}",
baselang	=>	"$config{'baselang'}",
persite		=>	"8",
username	=>	"$config{'username'}",
password	=>	"$config{'password'}",
hostname	=>	"$config{'host'}",
dbname		=>	"$config{'datenbank'}",
dbusername	=>	"$config{'dbusername'}",
dbuserpass	=>	"$config{'dbuserpass'}",
version		=>	"1.1.2 Gold",
treiber		=>	"$config{'driver'}",
pop		=>	"/www/htdocs/username/glossar/upload",
mufs		=>	'10240',
prefix		=>	'gif jpg png jpeg',
adminmail	=>	'webmaster@yourdomain.com',
sendmail	=>	"/usr/sbin/sendmail",
dbwords 	=>	'viscacha_words'
);
1;
~;
  		close(FILE);

	print qq~
	Step 2<br>
	<b>Data saved:</b><br><br>
	<blockquote>
htmldir		=>	"$config{'htmldir'}",<br>
baselang	=>	"$config{'baselang'}",<br>
username	=>	"$config{'username'}",<br>
password	=>	"$config{'password'}",<br>
hostname	=>	"$config{'host'}",<br>
dbname		=>	"$config{'datenbank'}",<br>
dbusername	=>	"$config{'dbusername'}",<br>
dbuserpass	=>	"$config{'dbuserpass'}",<br>
treiber		=>	"$config{'driver'}",<br>
dbwords 	=>	'$config{'dbwords'}'<br>
</blockquote><br><br>
	<a href="update.cgi?action=step3">next Step: CHMOD/Finish installtion</a>
	~

}

elsif ($input{action} eq "step3") {

chmod(0755, "./words.cgi");
chmod(0755, "./admin.cgi");
chmod(0755, "./print.cgi");

require "config.cgi";
use vars qw(%config); 

print qq~
Step 3<br>
CHMOD ready...<br><br>
Installation finished<br><br>
You can go to your Admincenter, now.<br>
Admincenter: <a href="admin.cgi?username=$config{'username'}&password=$config{'password'}">Go to...</a><br>
Glossary: <a href="words.cgi?">Go to ...</a><br>
~;

unlink "./env.cgi";
if (unlink "./setup.cgi") {}
else {print qq~<br>Atteintion: DELETE setup.cgi!~;}
if (unlink "./update.cgi") {}
else {print qq~<br>Attiention: DELETE update.cgi!~;}
exit;

}

else {

chmod(0755, "./env.cgi");

print qq~
<p align="center">Welcome to the update from Viscacha Glossar 1.0.x</p>
<p>If you need help with your system-configuration, look here: <a href="env.cgi">ENV.cgi</a></p>
<p align="center"><a href="update.cgi?action=step1">next Step: Settings</a></p>
~;

}